## mx-locale 24.1.11

=== debian/changelog ===
mx-locale (24.1.11) mx; urgency=medium

  * Typo fix, new translations

 -- Adrian <adrian@mxlinux.org>  Fri, 19 Jan 2024 20:14:42 -0500

mx-locale (24.1.10) mx; urgency=medium

  * Allow only UTF-8 locale to be sectabled as system locale
  * Add locale titles/names in the list
  * Add option to reset locale.gen
  * Add search field in Manage Locales tab

 -- Adrian <adrian@mxlinux.org>  Thu, 18 Jan 2024 17:17:40 -0500

mx-locale (24.1.09) mx; urgency=medium

  * adjust regexp patterns, two+three letter language and 2 letter regional code
  * ignore commented out locale in SUPPORTED
  * trim spaces in updated locale.gen
  * remove locale duplicates

 -- fehlix <fehlix@mxlinux.org>  Wed, 17 Jan 2024 15:39:25 -0500

mx-locale (24.1.08) mx; urgency=medium

  * allow enabling of any locale, no check against running or system locale

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Tue, 16 Jan 2024 13:20:49 -0500

mx-locale (24.1.07) mx; urgency=medium

  * Don't disable current session lang when disabing all the other locales

 -- Adrian <adrian@mxlinux.org>  Tue, 16 Jan 2024 11:24:35 -0500

mx-locale (24.1.06) mx; urgency=medium

  * filter iso out of choose dialog 

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sun, 14 Jan 2024 22:56:48 -0500

mx-locale (24.1.05) mx; urgency=medium

  * revise regular expression for uncommenting locales
  * misc. typo and string adjustments

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sun, 14 Jan 2024 20:50:36 -0500

mx-locale (24.1.04) mx; urgency=medium

  * use /usr/share/i18n/SUPPORTED AND /usr/local/share/i18n/SUPPORTED for available locales list
  * add to locale.gen if missing when enabling a locale for generation
  * don't allow disable of locale if in use as LANG
  * adjustments to Cmd

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sun, 14 Jan 2024 15:09:41 -0500

mx-locale (24.1.03) mx; urgency=medium

  * add message about taking effect on login

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sat, 13 Jan 2024 14:43:51 -0500

mx-locale (24.1.02) mx; urgency=medium

  * Added icon
  * Renamed tabs
  * Use UTF-8 insted of utf8
  * Use selected LANG from button instead of $LANG when disabing other locales

 -- Adrian <adrian@mxlinux.org>  Fri, 12 Jan 2024 21:15:26 -0500

mx-locale (24.1.01) mx; urgency=medium

  * Various improvements

 -- Adrian <adrian@mxlinux.org>  Thu, 11 Jan 2024 14:42:29 -0500

mx-locale (24.01.01) mx; urgency=medium

  * Initial build

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sat, 06 Jan 2024 13:51:05 -0500

## mx-locale 24.1.12

=== debian/changelog ===
mx-locale (24.1.12) mx; urgency=medium

  * Bump version, needed for Bullseye update

 -- Adrian <adrian@mxlinux.org>  Sun, 21 Jan 2024 12:50:38 -0500

## mx-locale 24.1.13

=== debian/changelog ===
mx-locale (24.1.13) mx; urgency=medium

  * Adjust regexp of the C.UTF-8 or C.utf8 pattern
  * Use LANG=C and LC_ALL=C for locale list

 -- fehlix <fehlix@mxlinux.org>  Tue, 23 Jan 2024 11:43:26 -0500

## mx-locale 24.1.14

=== debian/changelog ===
mx-locale (24.1.14) mx; urgency=medium

  * Fix crash when pressing OK without selecting any item
  * Update translations 

 -- Adrian <adrian@mxlinux.org>  Wed, 24 Jan 2024 18:25:00 -0500

## mx-locale 24.1.15

=== debian/changelog ===
mx-locale (24.1.15) mx; urgency=medium

  * Use "UTF-8" instead of "utf8" to avoid locale warnings

 -- fehlix <fehlix@mxlinux.org>  Sun, 28 Jan 2024 14:03:08 -0500

## mx-locale 24.3

=== debian/changelog ===
mx-locale (24.3) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Mar 2024 12:52:18 -0400

## mx-locale 25.10.1

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2024 MX Authors
# *
# * Authors: Dolphin Oracle
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of mx-locale.
# *
# * mx-locale is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * mx-locale is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with mx-locale.  If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************/

cmake_minimum_required(VERSION 3.16)

# Get version from debian/changelog
execute_process(
    COMMAND dpkg-parsechangelog -SVersion
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE DPKG_RESULT
)

if(NOT DPKG_RESULT EQUAL 0)
    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
endif()

project(mx-locale
    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
    DESCRIPTION "MX Locale - Locale configuration tool for MX Linux"
    LANGUAGES CXX
)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable compile commands export for IDEs and tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Optimize for Ninja builds
if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Enable colored output for Ninja
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    LinguistTools
)

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Define source files
set(SOURCES
    main.cpp
    mainwindow.cpp
    choosedialog.cpp
    about.cpp
    cmd.cpp
)

set(HEADERS
    mainwindow.h
    choosedialog.h
    about.h
    cmd.h
    common.h
)

set(UI_FILES
    mainwindow.ui
    choosedialog.ui
)

set(RESOURCE_FILES
    images.qrc
)

# Get all translation files
file(GLOB TRANSLATION_FILES "translations/*.ts")

# Create the executable
add_executable(mx-locale
    ${SOURCES}
    ${HEADERS}
    ${UI_FILES}
    ${RESOURCE_FILES}
)

# Link Qt6 libraries
target_link_libraries(mx-locale
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
)

# Set compiler flags
target_compile_options(mx-locale PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
    -Werror
)

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(mx-locale PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(mx-locale PRIVATE -Werror=return-local-addr)
endif()

# Set compile definitions
target_compile_definitions(mx-locale PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
    VERSION="${PROJECT_VERSION}"
)

# Release-specific optimizations
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(mx-locale PRIVATE NDEBUG)
    target_compile_options(mx-locale PRIVATE -O3)

    # Add LTO - different flags for different compilers
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
        target_compile_options(mx-locale PRIVATE -flto=thin)
        target_link_options(mx-locale PRIVATE -flto=thin)
    else()
        target_compile_options(mx-locale PRIVATE -flto=auto)
        target_link_options(mx-locale PRIVATE -flto=auto)
    endif()
endif()

# Handle translations
qt6_add_translations(mx-locale
    TS_FILES ${TRANSLATION_FILES}
    LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
    QM_FILES_OUTPUT_VARIABLE qm_files
)



# Set target properties
set_target_properties(mx-locale PROPERTIES
    OUTPUT_NAME "mx-locale"
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)



# Install target (required by Debian build system)
# Other files are handled by debian/install
install(TARGETS mx-locale
    RUNTIME DESTINATION bin
)

## mx-locale 24.11.01

=== debian/changelog ===
mx-locale (24.11.01) mx; urgency=medium

  * adjust about.cpp to launch help when not running root

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sun, 24 Nov 2024 09:36:23 -0500

mx-locale (24.5.02) mx; urgency=medium

  * Add button to "Remove MX manuals for languages other than system default"
  * Rename "System Locale" to "System Language" and move the remove manuals button to that tab

 -- Adrian <adrian@mxlinux.org>  Sun, 12 May 2024 23:22:19 -0400

=== debian/control ===
Source: mx-locale
Section: admin
Priority: optional
Maintainer: Dolphin Oracle <dolphinoracle@gmail.com>
Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8

Package: mx-locale
Architecture: any
Depends: locales, mx-viewer | antix-viewer| xdg-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: mx-launcher-l10n, gksu | pkexec
Description: set system language and locale variables
 gui front end to update-locales to set system language and locale variables

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=5

QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
MAKE_OPTS  = QMAKE=qmake-qt5 LRELEASE=lrelease-qt5 QMAKE_OPTS="$(QMAKE_OPTS)"

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/translations/*.qm

override_dh_auto_build:
	lrelease translations/*.ts
	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/#define VERSION \"\1\"/" > version.h
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

override_dh_builddeb:
	dh_builddeb -- -Z xz

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --no-automatic-dbgsym --parallel

## mx-locale 25.08

=== debian/changelog ===
mx-locale (25.08) mx; urgency=medium

  * Add 'Select sale locale for all categories' button

 -- Adrian <adrian@mxlinux.org>  Sun, 03 Aug 2025 11:10:11 -0400

mx-locale (25.4) mx; urgency=medium

  * Update to Qt6
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Thu, 24 Apr 2025 10:40:50 -0400

=== debian/control ===
Source: mx-locale
Section: admin
Priority: optional
Maintainer: Dolphin Oracle <dolphinoracle@gmail.com>
XSBC-Original-Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper-compat (= 13),
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/MX-Linux/mx-locale
Homepage: https://github.com/MX-Linux/mx-locale

Package: mx-locale
Architecture: any
Depends: locales,
         xdg-utils | mx-viewer,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Locale configuration tool for MX Linux
 MX Locale is a graphical utility that allows users to easily
 configure system language and locale settings. It provides
 a user-friendly interface for selecting and applying language
 preferences without requiring manual editing of configuration
 files or command line knowledge.

## mx-locale 25.08.1

=== debian/changelog ===
mx-locale (25.08.1) mx; urgency=medium

  * Remove 'Set same locale for all categories' button

 -- Adrian <adrian@mxlinux.org>  Tue, 05 Aug 2025 18:55:45 -0400

## mx-locale 25.10.1

=== debian/changelog ===
mx-locale (25.10.1) mx; urgency=medium

  * Fix: special case removal function for pt-br locale

 -- Adrian <adrian@mxlinux.org>  Sat, 11 Oct 2025 22:50:46 -0400

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,7 @@
 Priority: optional
 Maintainer: Dolphin Oracle <dolphinoracle@gmail.com>
 XSBC-Original-Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper-compat (= 13),
-               qt6-base-dev,
-               qt6-base-dev-tools,
-               qt6-tools-dev,
-               qt6-tools-dev-tools
+Build-Depends: debhelper-compat (=12), cmake (>= 3.16), ninja-build, qt6-base-dev, qt6-base-dev-tools, qt6-tools-dev, qt6-tools-dev-tools
 Standards-Version: 3.9.8
 Vcs-Git: git://github.com/MX-Linux/mx-locale
 Homepage: https://github.com/MX-Linux/mx-locale

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

override_dh_auto_configure:
	dh_auto_configure -- \
		-G Ninja \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=ON

override_dh_auto_clean:
	dh_auto_clean
	rm -f translations/*.qm

override_dh_auto_build:
	/usr/lib/qt6/bin/lrelease translations/*.ts
	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/const QString VERSION {\"\1\"};/" > version.h
	dh_auto_build

override_dh_auto_test:
	# Skip tests - no tests defined in project

override_dh_auto_install:
	dh_auto_install

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --buildsystem=cmake+ninja --no-automatic-dbgsym

## mx-locale 26.01.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,17 +22,53 @@
 
 cmake_minimum_required(VERSION 3.16)
 
-# Get version from debian/changelog
-execute_process(
-    COMMAND dpkg-parsechangelog -SVersion
-    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
-    OUTPUT_STRIP_TRAILING_WHITESPACE
-    RESULT_VARIABLE DPKG_RESULT
-)
-
-if(NOT DPKG_RESULT EQUAL 0)
-    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
+set(PROJECT_VERSION_FROM_CHANGELOG "")
+set(DPKG_RESULT 1)
+
+if(DEFINED PROJECT_VERSION_OVERRIDE AND NOT "${PROJECT_VERSION_OVERRIDE}" STREQUAL "")
+    set(PROJECT_VERSION_FROM_CHANGELOG "${PROJECT_VERSION_OVERRIDE}")
+    message(STATUS "Using version override: ${PROJECT_VERSION_FROM_CHANGELOG}")
+else()
+    find_program(DPKG_PARSECHANGELOG dpkg-parsechangelog)
+    if(DPKG_PARSECHANGELOG)
+        execute_process(
+            COMMAND ${DPKG_PARSECHANGELOG} -SVersion
+            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+            OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
+            OUTPUT_STRIP_TRAILING_WHITESPACE
+            RESULT_VARIABLE DPKG_RESULT
+            ERROR_QUIET
+        )
+    endif()
+
+    if(DPKG_RESULT EQUAL 0 AND NOT "${PROJECT_VERSION_FROM_CHANGELOG}" STREQUAL "")
+        message(STATUS "Using version from debian/changelog: ${PROJECT_VERSION_FROM_CHANGELOG}")
+    elseif(EXISTS ${CMAKE_SOURCE_DIR}/debian/changelog)
+        file(READ ${CMAKE_SOURCE_DIR}/debian/changelog PROJECT_CHANGELOG_CONTENT)
+        string(REGEX MATCH "^[^\\(]*\\(([^)]+)\\)" _match "${PROJECT_CHANGELOG_CONTENT}")
+        if(NOT _match)
+            message(FATAL_ERROR "Could not parse version from debian/changelog")
+        endif()
+        set(PROJECT_VERSION_FROM_CHANGELOG "${CMAKE_MATCH_1}")
+        message(STATUS "Using version parsed from debian/changelog: ${PROJECT_VERSION_FROM_CHANGELOG}")
+    elseif(EXISTS ${CMAKE_SOURCE_DIR}/PKGBUILD)
+        file(READ ${CMAKE_SOURCE_DIR}/PKGBUILD PKGBUILD_CONTENT)
+        string(REGEX MATCH "\n?pkgver=([^\n\r]+)" _match "${PKGBUILD_CONTENT}")
+        if(NOT _match)
+            message(FATAL_ERROR "Could not parse version from PKGBUILD")
+        endif()
+        set(PROJECT_VERSION_FROM_CHANGELOG "${CMAKE_MATCH_1}")
+        string(STRIP "${PROJECT_VERSION_FROM_CHANGELOG}" PROJECT_VERSION_FROM_CHANGELOG)
+        string(REGEX REPLACE "^\"|\"$" "" PROJECT_VERSION_FROM_CHANGELOG "${PROJECT_VERSION_FROM_CHANGELOG}")
+        string(REGEX REPLACE "^'|'$" "" PROJECT_VERSION_FROM_CHANGELOG "${PROJECT_VERSION_FROM_CHANGELOG}")
+        string(REGEX MATCH "^\\$\\{PKGVER:-([^}]+)\\}$" _pkgver_match "${PROJECT_VERSION_FROM_CHANGELOG}")
+        if(_pkgver_match)
+            set(PROJECT_VERSION_FROM_CHANGELOG "${CMAKE_MATCH_1}")
+        endif()
+        message(STATUS "Using version parsed from PKGBUILD: ${PROJECT_VERSION_FROM_CHANGELOG}")
+    else()
+        message(FATAL_ERROR "Could not determine version: dpkg-parsechangelog not available and no debian/changelog or PKGBUILD")
+    endif()
 endif()
 
 project(mx-locale
@@ -40,6 +76,8 @@
     DESCRIPTION "MX Locale - Locale configuration tool for MX Linux"
     LANGUAGES CXX
 )
+
+option(ARCH_BUILD "Build with Arch-specific adjustments" OFF)
 
 # Set C++ standard
 set(CMAKE_CXX_STANDARD 20)
@@ -148,6 +186,10 @@
     VERSION="${PROJECT_VERSION}"
 )
 
+if(ARCH_BUILD)
+    target_compile_definitions(mx-locale PRIVATE MX_LOCALE_ARCH)
+endif()
+
 # Release-specific optimizations
 if(CMAKE_BUILD_TYPE STREQUAL "Release")
     target_compile_definitions(mx-locale PRIVATE NDEBUG)

=== debian/changelog ===
mx-locale (26.01.3) mx; urgency=medium

  * use relative symlink
  * fix etc/default/locale symlink if its missing

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Tue, 20 Jan 2026 22:04:43 -0500

mx-locale (26.01.1) mx; urgency=medium

  * handle debian 13 style locale.conf file
  * don't break symlink during locale managmenet

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Tue, 20 Jan 2026 19:53:41 -0500
